/*	
 *	clipbary.h
 *
 *	ėprbgz
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001-2014 Naoyuki Sawa
 *
 *	* Tue Dec 20 00:06:44 JST 2011 Naoyuki Sawa
 *	- 1st [XB
 *	* Thu Nov 20 20:22:14 JST 2014 Naoyuki Sawa
 *	- LSBso[WɉāAMSBso[W쐬܂B
 *	- bitarray_get(),bitarray_set()Abitarray_lsb1st_get(),bitarray_lsb1st_set()ɖ̕ύX܂B
 *	- VKɁAbitarray_msb1st_get(),bitarray_msb1st_set()ǉ܂B
 *	  bitarray_msb1st_get(),bitarray_msb1st_set()͂܂AAZuĂ܂B
 *	* Sat Nov 22 11:57:45 JST 2014 Naoyuki Sawa
 *	- bitarray_msb1st_get()AZu܂B
 *	  ̏Ձ`Ղ́Abitarray_lsb1st_get()̃AZułƂقړŁAVtgႤłB
 *	  ̏IՂ́Abitarray_lsb1st_get()ƈقȂA}XNKv̂ŁAPɂȂ܂B
 *	- HuffmanDecoder_Decode()gpāACłƓʂɂȂ邱Ƃ𓮍mF܂B
 *	  HuffmanDecoder_Decode()ŁA39KB˖62KB̓WJs̑xA1.203b˖1.106bɍ܂B(Clock=48MHz,Stack=FRAM)
 *	  bitarray_msb1st_get()P̂ŁAǂꂮ炢́A܂vĂ܂B
 *	* Sat Nov 22 13:00:53 JST 2014 Naoyuki Sawa
 *	- bitarray_msb1st_set()AZu܂B
 *	  ̏ՂƏIՂ́Abitarray_lsb1st_set()̃AZułƂقړŁAVtgႤłB
 *	  ̒Ղ́Abitarray_lsb1st_set()ƈقȂA}XNƒlꂼɃVtg悤ɂȂ܂B
 *	- HuffmanEncoder_Encode()gpāACłƓʂɂȂ邱Ƃ𓮍mF܂B
 *	  HuffmanEncoder_Encode()ŁA62KB˖39KB̈ks̑xA12.91b˖12.69bɍ܂B(Clock=48MHz,Stack=FRAM)
 *	  bitarray_msb1st_set()P̂ŁAǂꂮ炢́A܂vĂ܂B
 *	* Sat Nov 29 10:50:31 JST 2014 Naoyuki Sawa
 *	- bitarray_lsb1st_get(),bitarray_msb1st_get()Aclipbary.cframbary.c֕܂B
 *	  HuffmanDecoder_Decode()ŁA39KB˖62KB̓WJs̑xAȉ̂悤ɍ܂B(Clock=48MHz,Code=FRAM,Stack=FRAM)
 *	  RAMɔzu郂W[:                ˖0.756b
 *	  RAMɔzu郂W[:frambary.o          ˖0.586b
 *	  RAMɔzu郂W[:framhfm.o           ˖0.418b
 *	  RAMɔzu郂W[:frambary.o+framhfm.o˖0.248b
 */
#ifndef __CLIP_BARY_H__
#define __CLIP_BARY_H__

/*****************************************************************************
 *	
 *****************************************************************************/

/* rbgz̃mۂ܂B
 * [in]
 *	bit_len		rbgB
 * [out]
 *	߂l		rbgz̐擪AhXB
 * [note]
 *	* rbgz̃̈́Ã}NȊO̕@gĊmۂĂ\܂B
 *	  ÓIȃ̈Aʂ̕@Ŋmۂ̈ɑ΂āArbgz̑sƂ\łB
 *	- AK32rbgACgꂽ̈ƂĂB
 *	  ̂߁Abitarray_?sb1st_get()bitarray_?sb1st_set()A32rbgPʂŏs悤ɎłB
 *	- 8rbgPʂŏs悤ɂ΁A32rbgACg͖̐Ȃ̂łA
 *	  pɂɃrbgz𑀍삷ꍇAx̕dvƍlāA32rbgPʂŏsɂ܂B
 */
#define bitarray_alloc(bit_len) (calloc(((bit_len) + 31) >> 5, 4)) /* w肳ꂽbitA32bitPʂɐ؂グāAintzƂĊmۂ܂ */

/* rbgz̃J܂B
 * [in]
 *	ptr		rbgz̐擪AhXB
 */
#define bitarray_free(ptr) do { free(ptr); } while(0)

/* rbgz̔Cӂ̈ʒuA{1`32}rbgl擾܂B
 * [in]
 *	ptr		rbgz̐擪AhXB
 *	pos		rbgz̐擪Arbgڂ̈ʒuAl擾邩B
 *	bits		擾l̃rbgB
 * [out]
 *	߂l		擾lB
 * [note]
 *	* 1rbgAyсA32rbg߂̑͑ΉĂ܂B
 *	  bits1ÁA32߂̒lw肷ƁACł͎̎sG[,ASMł͓얢`ƂȂ܂B
 *	* 31rbgȉ̒l擾ꍇAŏʃrbg͕g *܂* B
 *	  31rbgȉ̒lAtƂĈꍇ́AĂяoŕgĂB
 */
int bitarray_lsb1st_get(const void* ptr, int pos, int bits);		//LSBso[W
int bitarray_msb1st_get(const void* ptr, int pos, int bits);		//MSBso[W

/* rbgz̔Cӂ̈ʒuɁA{1`32}rbgli[܂B
 * [in]
 *	ptr		rbgz̐擪AhXB
 *	pos		rbgz̐擪Arbgڂ̈ʒuɁAli[邩B
 *	bits		i[l̃rbgB
 *	value		i[lB
 * [note]
 *	* 1rbgAyсA32rbg߂̑͑ΉĂ܂B
 *	  bits1ÁA32߂̒lw肷ƁACł͎̎sG[,ASMł͓얢`ƂȂ܂B
 *	* valuéAsvȏʃrbǵA{֐Ń}XN܂B
 *	  ĂяoŁA}XNĂKv͂܂B
 */
void bitarray_lsb1st_set(void* ptr, int pos, int bits, int value);	//LSBso[W
void bitarray_msb1st_set(void* ptr, int pos, int bits, int value);	//MSBso[W

/*****************************************************************************
 *	
 *****************************************************************************/

//	gpPFIɊmۂrbgz̃gpB
//	void* ba = bitarray_lsb1st_alloc(321);		//321rbgmہB؂グ324rbg(81[h)mۂ
//	bitarray_lsb1st_set(ba, 100, 24, 0xFEDCBA);	//100rbgڂA24rbg͈̔͂ɁA0xFEDCBAi[
//	tmp = bitarray_lsb1st_get(ba, 100, 24);		//100rbgڂA24rbg擾B0x00FEDCBAԂ	//g0xFFFEDCBAɂ*ȂȂ*Ƃɒ

//	gpQFÓIɍ쐬rbgz̃f[^gpB
//	//                   +-------------------31rbg
//	//                   |      +------------ 0rbg
//	//                   |      |   +--------63rbg
//	//                   |      |   |      +-32rbg
//	const int ba[2] = {0x76543210,0xFEDCBA98};
//	tmp = bitarray_lsb1st_get(ba, 20, 16);		//20rbgڂA16rbg擾B0x00008765Ԃ	//g0xFFFF8765ɂ*ȂȂ*Ƃɒ

/*****************************************************************************
 *	
 *****************************************************************************/

#endif /*__CLIP_BARY_H__*/
