// * Mon Dec 01 13:44:05 JST 2014 Naoyuki Sawa
// - 1st [XB
//   u/clip/tool/dRudSeqSvɂč쐬܂B
#include <clip.h>
/*---------------------------------------------------------------------------*/
#define VERSION "20141201"	/* o[W` */
/*---------------------------------------------------------------------------*/
int iDataLen;
uint16_t TBL_Data[1000000/**/];
/*---------------------------------------------------------------------------*/
void LoadXml(const char* pFileName);
void loadData(TiXmlElement* pRoot);
void simMoveDirect(uint32_t iInst);
/*---------------------------------------------------------------------------*/
__declspec(noreturn) static void usage() {
	fprintf(stderr, "dRudSeqD - pX[^[̑`V[PTtRpC (%s)\n", VERSION);
	fprintf(stderr, "Copyright (C) 2014 Naoyuki Sawa\n");
	fprintf(stderr, "\n");
	fprintf(stderr, "USAGE:\n");
	fprintf(stderr, "  dRudSeqD filename.xml\n");
	fprintf(stderr, "\n");
	fprintf(stderr, "OPTIONS:\n");
	fprintf(stderr, "  -h     g\܂B\n");
	fprintf(stderr, "\n");
	fprintf(stderr, "EXAMPLE:\n");
	fprintf(stderr, "  dRudSeqD sample.xml\n");
	fprintf(stderr, "  sample.xmlǍ݁AtRpCsAWo͂֏o͂܂B\n");
	fprintf(stderr, "  ̓t@C`́AdRudSeqSƓłB\n");
	fprintf(stderr, "\n");
	fprintf(stderr, "eXtension:\n");
	fprintf(stderr, "  vWFNgŗL̊gƂāA\n");
	fprintf(stderr, "  dRudSeqD -xf[^sCfNX filename.xml\n");
	fprintf(stderr, "  ڐ̃V~[Vs܂B\n");
	exit(EXIT_FAILURE);
}
/*---------------------------------------------------------------------------*/
int main(int argc, char* argv[]) {
	int opt, optX = -1;
	/* R}hCIvVB */
	opterr = 0; /* IvVG[͓vOŏ̂ŁAgetopt()ł̃G[\͕svB */
	while((opt = getopt(argc, argv, "hx:")) != -1) {
		switch(opt) {
		default:
		case 'h': usage();
		case 'x': optX = atoi(optarg); break;
		}
	}
	if(optind != (argc - 1)) { usage(); }
	/* XMLt@CǂݍށB */
	LoadXml(argv[optind]);
	/* '-x'IvVw肳ĂȂ΁c */
	if(optX == -1) {
		/* tRpCsB */
		RudSeq_Decompile(TBL_Data, iDataLen);
	/* '-x'IvVw肳Ăc */
	} else {
		if((unsigned)optX >= (unsigned)iDataLen) { die("-xIvV̈słB"); }
		/* ڐ̃V~[VsB */
		simMoveDirect(optX);
	}
	return EXIT_SUCCESS;
}
/*---------------------------------------------------------------------------*/
void LoadXml(const char* pFileName) {
	TiXmlDocument* pDoc = TiXmlDocument_new(NULL);
	TiXmlDocument_LoadFile(pDoc, pFileName);
	{
		TiXmlElement* pRoot = TiXmlNode_FirstChildElement(TiXmlDocument_super(pDoc), "Root");
		if(!pRoot) { DIE(); }
		loadData(pRoot);
	}
}
/*---------------------------------------------------------------------------*/
void loadData(TiXmlElement* pRoot) {
	TiXmlElement* pData = TiXmlNode_FirstChildElement(TiXmlElement_super(pRoot), "Data");
	if(!pData) { DIE(); }
	{
		TiXmlNode* pNode = TiXmlNode_FirstChild(TiXmlElement_super(pData), NULL);
		if(!pNode) { DIE(); }
		{
			TiXmlText* pText = TiXmlNode_ToText(pNode);
			if(!pText) { DIE(); }
			{
				char* p = strtok(strdup(TiXmlNode_Value(TiXmlText_super(pText))), ", ");
				while(p) {
					if(iDataLen >= ARRAY_SIZE(TBL_Data)) { DIE(); }
					TBL_Data[iDataLen++] = strtol(p, &p, 0);
					if(*p) { DIE(); }
					p = strtok(NULL, ", ");
				}
			}
		}
	}
}
/*===========================================================================*
 *	ڐ̃V~[VsB
 *===========================================================================*/
//uclip/clipruds.cvRudSeqCh_Exec()V~[Vpɉ̂łB
//uclip/clipruds.cvRudSeqCh_Exec()ύXۂ͓֐ύXĂB
/*---------------------------------------------------------------------------*/
static uint16_t Speed;		/* (0=ő) */
static uint8_t StackLevel;	/* X^bNx(0`RudSeqCh_StackSize) */
typedef struct _ST_Stack {
	uint32_t iInst;		/* ߂̖߃|C^ */
	 int16_t Repeat;	/* 0=CallX^bN,0ȊO=RepeatX^bN̎cJԂ(=) */
} ST_Stack;
static ST_Stack TBL_Stack[RudSeqCh_StackSize];
/*---------------------------------------------------------------------------*/
void simMoveDirect(uint32_t iInst) {
	int Hi, Lo;
	for(;;) {
		/* ߃R[h擾B */
		Hi = TBL_Data[iInst];
		Lo = (Hi & 0xFFF);	/* ߃R[h[11: 0] */
		Hi >>= 12;		/* ߃R[h[15:12] */
		/* ߃R[h[15:12]ɂāc */
		switch(Hi) {
		case 0:
			/* ߃R[h[11: 0]ɂāc */
			switch(Lo) {
			case 0: /* end */
				/* X^bNL΁c */
				if(StackLevel) {
					/* X^bN炷B */
					StackLevel--;
					/* RepeatX^bNȂ΁c */
					if(TBL_Stack[StackLevel].Repeat) {
						/* ,,cJԂ񐔂炵0łȂ΁c */
						if((TBL_Stack[StackLevel].Repeat < 0) ||
						 (--TBL_Stack[StackLevel].Repeat)) {
							/* ߃|C^ݒ肷B */
							iInst = TBL_Stack[StackLevel].iInst;
							/* X^bN𑝂₷B */
							StackLevel++;
						}
					/* CallX^bNȂ΁c */
					} else {
						/* ߃|C^ݒ肷B */
						iInst = TBL_Stack[StackLevel].iInst;
					}
				/* X^bN΁c */
				} else {
					/* ĐIB */
					return; /* ܂ */
				}
				break;
			case 1: /* wait stop */
				printf("%s\n", "wait stop");
				break;
			case 2: /* move init */
			case 3: /* move stop */
				die("%04X g@\͒ڐȊO̼Эڰ݂z肵Ă܂B\n", iInst);
			default: /* user u */
				/** no job **/							//عݒ`̏ͤg@\̼Эڰ݌ʂɉeȂ̂Ɖ肵Ĥuser uo͂ȂƂɂ
				break;
			}
			break;
		case 1: /* wait rel */
			/* O̖ߊ̑ΎԂAw肳ꂽΎԂɓBĂȂ΁c */
			printf("%s %u\n", "wait rel", Lo);
			break;
		case 2: /* goto */
			/* ߃|C^ݒ肷B */
			if(!Lo) { DIE(); } /* f[^oO */					//gotoߎgւgoto͖炩Ƀf[^oOłB
			iInst += (((int16_t)(Lo<<4))>>4) - 1/*ʏ́u+1v𑊎E*/;
			break;
		case 3: /* call */
			if((unsigned)StackLevel >= RudSeqCh_StackSize) { DIE(); }		/* RudSeqCh_StackSize𒲐 */
			/* ߂̖߃|C^i[B */
			TBL_Stack[StackLevel].iInst = iInst;					//u`=iInst+1/*̖*/;vł͂ȂƂɒӂBu+1v͖߂莞end̎s̋ʏōs邩B
			/* CallX^bNł邱ƂB */
			TBL_Stack[StackLevel].Repeat = 0;
			/* X^bN𑝂₷B */
			StackLevel++;
			/* ߃|C^ݒ肷B */
			if(!Lo) { DIE(); } /* f[^oO */					//callߎgւcall͖炩Ƀf[^oOłB
			iInst += (((int16_t)(Lo<<4))>>4) - 1/*ʏ́u+1v𑊎E*/;
			break;
		case 4:
			Hi = Lo;
			Lo = (Hi & 0x3FF);	/* ߃R[h[ 9: 0] */
			Hi >>= 10;		/* ߃R[h[11:10] */
			/* ߃R[h[11:10]ɂāc */
			switch(Hi) {
			case 0: /* repeat */
				if((unsigned)StackLevel >= RudSeqCh_StackSize) { DIE(); }	/* RudSeqCh_StackSize𒲐 */
				/* ߂̖߃|C^i[B */
				TBL_Stack[StackLevel].iInst = iInst;				//u`=iInst+1/*̖*/;vł͂ȂƂɒӂBu+1v͖߂莞end̎s̋ʏōs邩B
				/* RepeatX^bN̎cJԂ񐔂i[B */
				TBL_Stack[StackLevel].Repeat = Lo ? Lo : -1/**/;
/*{{ЭڰݓL}}*/		if(TBL_Stack[StackLevel].Repeat == -1) { TBL_Stack[StackLevel].Repeat = 10; }	//Эڰ݂IȂȂ邱Ƃhߤٰ߂10ɒuļЭڰ݂sƂɂ
				/* X^bN𑝂₷B */
				StackLevel++;
				break;
			case 1: /* speed */
				/* ݒ肷B */
				Speed = Lo;
				printf("%s %u\n", "speed", Lo);
				break;
			case 2: /* move rel */
			default: /* move abs */
				die("%04X g@\͒ڐȊO̼Эڰ݂z肵Ă܂B\n", iInst);
				break;
			}
			break;
		case 5: /* move direct if on */
		case 6: /* move direct if off */
		case 7: /* move direct always */
			/* ``l̓sB */
			if(Speed && Lo) {
				static const char* TBL_CondIf[]  ={""," if on"     ," if off"    ," always"    };
				static const char* TBL_CondWhen[]={""," until rise"," until fall"," until edge"};
				printf("%s %d%s%s\n", "move direct", ((int16_t)(Lo<<6))>>6, TBL_CondIf[(Lo>>12)&3], TBL_CondWhen[(Lo>>10)&3]);
			} else {
				printf("%s\n", "move stop direct");
			}
			break;
		default: /* wait abs */
			/* f[^ĐJn̐ΎԂAw肳ꂽΎԂɓBĂȂ΁c */
			printf("%s %u\n", "wait abs", ((Hi&7)<<12)|Lo);
			break;
		}
		/* ߃|C^i߂B */
		iInst++;									//end,goto,call̒߃|C^iނƂɒӂB
	}
}
